﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class Contract : Form
    {
        string id_contract; // Переменные для передачи на форму измения
        string contract;
        string cena;
        string percent;
        string count_hours;
        bool save;
        DataBase dataBase = new DataBase();
        public Contract()
        {
            InitializeComponent();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            MainMenu mainMenu = new MainMenu();
            mainMenu.ShowDialog();
        }
        private void CreateColumns() // Создание столбцов
        {
            dataGridView1.Columns.Add("id_contract", "id");
            dataGridView1.Columns.Add("contract", "Наименование");
            dataGridView1.Columns.Add("cena", "Цена (руб.)");
            dataGridView1.Columns.Add("percent", "% даваемой скидки");
            dataGridView1.Columns.Add("count_hours", "Часов в месяц");
            dataGridView1.Columns.Add("", String.Empty);
        }
        private void ReadSingleRow(DataGridView dgw, IDataRecord record) // Вывод данных
        {
            dgw.Rows.Add(record.GetInt32(0), record.GetString(1), record.GetDouble(2), record.GetDouble(3), record.GetDouble(4), RowState.ModifiedNew);
        }
        private void RefresDataGird(DataGridView dgw) // Взятие данных из БД
        {
            dgw.Rows.Clear();
            dataGridView1.Columns[0].Visible = false;
            dataGridView1.Columns[5].Visible = false;
            string queryString = $"Select id_contract, contract, cena, [percent], count_hours From Contract"; // Запрос для вывода данных
            SqlCommand command = new SqlCommand(queryString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader reader = command.ExecuteReader();
            while (reader.Read())
            {
                ReadSingleRow(dgw, reader);
            }
            reader.Close();
        }
        private void Contract_Load(object sender, EventArgs e)
        {
            CreateColumns();
            RefresDataGird(dataGridView1);
        }

        private void button_add_Click(object sender, EventArgs e)
        {
            this.Hide();
            ContractAdd contractAdd = new ContractAdd();
            contractAdd.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button_insert_Click(object sender, EventArgs e) // Переход на форму изменения
        {
            if (id_contract == null)
            {
                MessageBox.Show("Не выделена строчка для изменения");
            }
            else
            {
                this.Hide();
                ContractUpd contractUpd = new ContractUpd(id_contract, contract, cena, percent, count_hours);
                contractUpd.ShowDialog();
            }
        }

        private void button_delete_Click(object sender, EventArgs e) // При нажатие на кнопку удалить
        {
            dataBase.openConnection();
            string admin = $"SELECT C.id_contract From Contract C inner join Client Cl ON C.id_contract = Cl.id_contract WHERE C.id_contract = '{id_contract}'"; // Проверка наличия связей
            SqlDataAdapter sda = new SqlDataAdapter(admin, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count < 1)
            {
                if (id_contract == null)
                {
                    MessageBox.Show("Не выделена запись для удаления!!!");
                }
                else
                {
                    deleteRow();
                    save = true;
                }
            }
            else
            {
                MessageBox.Show("Нельзя удалить запись, на которую есть ссылка!!!");
            }
            dataBase.closeConnection();
        }
        private void deleteRow() // Пометка на удаление
        {
            int index = dataGridView1.CurrentCell.RowIndex;
            dataGridView1.Rows[index].Visible = false;
            if (dataGridView1.Rows[index].Cells[0].Value.ToString() == String.Empty)
            {
                dataGridView1.Rows[index].Cells[5].Value = RowState.Deleted;
                return;
            }
            dataGridView1.Rows[index].Cells[5].Value = RowState.Deleted;
            id_contract = null;
        }
        new private void Update() // Сохранение изменений
        {
            dataBase.openConnection();
            for (int index = 0; index < dataGridView1.Rows.Count; index++)
            {
                var rowState = (RowState)dataGridView1.Rows[index].Cells[5].Value;
                if (rowState == RowState.Existed)
                    continue;
                if (rowState == RowState.Deleted)
                {
                    var id = dataGridView1.Rows[index].Cells[0].Value;
                    var deleteQuery = $"delete from Contract where id_contract = {id}";
                    var command = new SqlCommand(deleteQuery, dataBase.GetConnection());
                    command.ExecuteNonQuery();
                }
            }
            dataBase.closeConnection();
        }

        private void StrokaSearch_TextChanged(object sender, EventArgs e) // При введение данных в строку поиска
        {
            Search(dataGridView1);
        }
        private void Search(DataGridView dgw) // Поиск
        {
            dgw.Rows.Clear();
            string searchString = $"Select id_contract, contract, cena, [percent], count_hours from Contract Where contract like '%" + StrokaSearch.Text + "%'";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                ReadSingleRow(dgw, read);
            }
            read.Close();
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }

        private void labelUpdate_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (save == true)
            {
                Update();
                save = false;
            }
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e) // Выделение записи в dataGriedViev
        {
            var selectedRow = e.RowIndex;
            if (e.RowIndex >= 0)
            {
                dataBase.openConnection();
                DataGridViewRow row = dataGridView1.Rows[selectedRow];
                id_contract = row.Cells[0].Value.ToString();
                contract = row.Cells[1].Value.ToString();
                cena = row.Cells[2].Value.ToString();
                percent = row.Cells[3].Value.ToString();
                count_hours = row.Cells[4].Value.ToString();
                dataBase.closeConnection();
            }
        }
        private void labelUpdate_MouseEnter(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.Black;
        }

        private void labelUpdate_MouseLeave(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.FromArgb(4, 52, 108);
        }
    }
}
