﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class OrderUpplier : Form // Форма добавления заказа поставщику
    {
        string id_order_upplier; // Переменные для формы изменения
        string order_status;
        string supplier;
        string product;
        string quantity;
        string price;
        string summa;
        bool save;
        DataBase dataBase = new DataBase();
        public OrderUpplier()
        {
            InitializeComponent();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            MainMenu main = new MainMenu();
            main.ShowDialog();
        }
        private void CreateColumns() // Создание столбцов
        {
            dataGridView1.Columns.Add("id_order_upplier", "id");
            dataGridView1.Columns.Add("id_order_status", "Статус товара");
            dataGridView1.Columns.Add("id_supplier", "Поставщик");
            dataGridView1.Columns.Add("product", "Наименование");
            dataGridView1.Columns.Add("quantity", "Количество");
            dataGridView1.Columns.Add("price", "Цена");
            dataGridView1.Columns.Add("summa", "Общая сумма");
            dataGridView1.Columns.Add("", String.Empty);
        }
        private void ReadSingleRow(DataGridView dgw, IDataRecord record) // Формирование данных
        {
            dgw.Rows.Add(record.GetInt32(0), record.GetString(1), record.GetString(2), record.GetString(3), record.GetInt32(4), record.GetDouble(5), record.GetDouble(6), RowState.ModifiedNew);
        }
        private void RefresDataGird(DataGridView dgw) // Нахождение данных в БД
        {
            dgw.Rows.Clear();
            dataGridView1.Columns[0].Visible = false;
            dataGridView1.Columns[7].Visible = false;
            string queryString = $"Select OU.id_order_upplier, OS.order_status, S.name_organization, OU.product, OU.quantity, OU.price, OU.summa From OrderUpplier OU inner join OrderStatus OS ON OU.id_order_status = OS.id_order_status inner join Suppliers S ON S.id_supplier = OU.id_supplier";
            SqlCommand command = new SqlCommand(queryString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader reader = command.ExecuteReader();
            while (reader.Read())
            {
                ReadSingleRow(dgw, reader);
            }
            reader.Close();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void OrderUpplier_Load(object sender, EventArgs e)
        {
            CreateColumns();
            RefresDataGird(dataGridView1);
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (save == true)
            {
                Update();
                save = false;
            }
        }

        private void labelUpdate_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }

        private void StrokaSearch_TextChanged(object sender, EventArgs e)
        {
            Search(dataGridView1);
        }
        private void Search(DataGridView dgw) // Поиск
        {
            dgw.Rows.Clear();
            string searchString = $"Select OU.id_order_upplier, OS.order_status, S.name_organization, OU.product, OU.quantity, OU.price, OU.summa From OrderUpplier OU inner join OrderStatus OS ON OU.id_order_status = OS.id_order_status inner join Suppliers S ON S.id_supplier = OU.id_supplier WHERE OU.product like '%" + StrokaSearch.Text + "%'";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                ReadSingleRow(dgw, read);
            }
            read.Close();
            dataBase.closeConnection();
        }
        private void deleteRow() // Пометка на удаление
        {
            int index = dataGridView1.CurrentCell.RowIndex;
            dataGridView1.Rows[index].Visible = false;
            if (dataGridView1.Rows[index].Cells[0].Value.ToString() == String.Empty)
            {
                dataGridView1.Rows[index].Cells[7].Value = RowState.Deleted;
                return;
            }
            dataGridView1.Rows[index].Cells[7].Value = RowState.Deleted;
            id_order_upplier = null;
        }
        new private void Update() // Принятие изменений
        {
            dataBase.openConnection();
            for (int index = 0; index < dataGridView1.Rows.Count; index++)
            {
                var rowState = (RowState)dataGridView1.Rows[index].Cells[7].Value;
                if (rowState == RowState.Existed)
                    continue;
                if (rowState == RowState.Deleted)
                {
                    var id = dataGridView1.Rows[index].Cells[0].Value;
                    var deleteQuery = $"delete from OrderUpplier where id_order_upplier = {id}";
                    var command = new SqlCommand(deleteQuery, dataBase.GetConnection());
                    command.ExecuteNonQuery();
                }
            }
            dataBase.closeConnection();
        }

        private void button_delete_Click(object sender, EventArgs e) // Пометка на удаление записи
        {
            dataBase.openConnection();
            string admin = $"SELECT W.id_work From OrderUpplier OU inner join Work W ON OU.id_order_upplier = W.id_order_upplier WHERE OU.id_order_upplier = '{id_order_upplier}'"; // Проверка на наличие ссылок
            SqlDataAdapter sda = new SqlDataAdapter(admin, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count < 1)
            {
                if (id_order_upplier == null)
                {
                    MessageBox.Show("Не выделена запись для удаления!!!");
                }
                else
                {
                    deleteRow();
                    save = true;
                }
            }
            else
            {
                MessageBox.Show("Нельзя удалить запись, на которую есть ссылка!!!");
            }
            dataBase.closeConnection();
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e) // Выделение записи в dataGriedViev
        {
            var selectedRow = e.RowIndex;
            if (e.RowIndex >= 0)
            {
                DataGridViewRow row = dataGridView1.Rows[selectedRow];
                id_order_upplier = row.Cells[0].Value.ToString();
                order_status = row.Cells[1].Value.ToString();
                supplier = row.Cells[2].Value.ToString();
                product = row.Cells[3].Value.ToString();
                quantity = row.Cells[4].Value.ToString();
                price = row.Cells[5].Value.ToString();
                summa = row.Cells[6].Value.ToString();
            }
        }

        private void button_add_Click(object sender, EventArgs e)
        {
            this.Hide();
            OrderUpplierAdd orderUpplierAdd = new OrderUpplierAdd();
            orderUpplierAdd.ShowDialog();
        }

        private void button_insert_Click(object sender, EventArgs e) // Переход на форму изменения
        {
            if (id_order_upplier == null)
            {
                MessageBox.Show("Не выделена строчка для изменения");
            }
            else
            {
                this.Hide();
                OrderUpplierUpd orderUpplierUpd = new OrderUpplierUpd(id_order_upplier, order_status, supplier, product, quantity, price, summa);
                orderUpplierUpd.ShowDialog();
            }
        }
        private void labelUpdate_MouseEnter(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.Black;
        }

        private void labelUpdate_MouseLeave(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.FromArgb(4, 52, 108);
        }
    }
}
