﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class Supplier : Form // Форма списка поставщиков
    {
        string id_supplier; // Переменные для передачи на форму измения
        string name_organization;
        string phone;
        string email;
        string address;
        bool save;
        DataBase dataBase = new DataBase();
        public Supplier()
        {
            InitializeComponent();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void CreateColumns() // Создание столбцов
        {
            dataGridView1.Columns.Add("id_supplier", "id");
            dataGridView1.Columns.Add("name_organization", "Название организации");
            dataGridView1.Columns.Add("phone", "Телефон");
            dataGridView1.Columns.Add("email", "Электронная почта");
            dataGridView1.Columns.Add("address", "Адрес");
            dataGridView1.Columns.Add("", String.Empty);
        }
        private void ReadSingleRow(DataGridView dgw, IDataRecord record) // Вывод данных
        {
            dgw.Rows.Add(record.GetInt32(0), record.GetString(1), record.GetString(2), record.GetString(3), record.GetString(4), RowState.ModifiedNew);
        }
        private void RefresDataGird(DataGridView dgw) // Взятие данных из БД
        {
            dgw.Rows.Clear();
            dataGridView1.Columns[0].Visible = false;
            dataGridView1.Columns[5].Visible = false;
            string queryString = $"Select id_supplier, name_organization, phone, email, address From Suppliers";
            SqlCommand command = new SqlCommand(queryString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader reader = command.ExecuteReader();
            while (reader.Read())
            {
                ReadSingleRow(dgw, reader);
            }
            reader.Close();
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e) // Выделение записи в dataGriedViev
        {
            var selectedRow = e.RowIndex;
            if (e.RowIndex >= 0)
            {
                DataGridViewRow row = dataGridView1.Rows[selectedRow];
                id_supplier = row.Cells[0].Value.ToString();
                name_organization = row.Cells[1].Value.ToString();
                phone = row.Cells[2].Value.ToString();
                email = row.Cells[3].Value.ToString();
                address = row.Cells[4].Value.ToString();
            }
        }

        private void StrokaSearch_TextChanged(object sender, EventArgs e)
        {
            Search(dataGridView1);
        }

        private void labelUpdate_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            MainMenu mainMenu = new MainMenu();
            mainMenu.ShowDialog();
        }

        private void button_add_Click(object sender, EventArgs e)
        {
            this.Hide();
            SupplierAdd supplierAdd = new SupplierAdd();
            supplierAdd.ShowDialog();
        }

        private void button_insert_Click(object sender, EventArgs e) // Переход на форму изменения
        {
            if (id_supplier == null)
            {
                MessageBox.Show("Не выделена строчка для изменения");
            }
            else
            {
                this.Hide();
                SupplierUpd supplierUpd = new SupplierUpd(id_supplier, name_organization, phone, email, address);
                supplierUpd.ShowDialog();
            }
        }
        private void Search(DataGridView dgw) // Поиск
        {
            dgw.Rows.Clear();
            string searchString = $"Select id_supplier, name_organization, phone, email, address From Suppliers Where name_organization like '%" + StrokaSearch.Text + "%'";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                ReadSingleRow(dgw, read);
            }
            read.Close();
        }
        private void deleteRow() // Пометка на удаление
        {
            int index = dataGridView1.CurrentCell.RowIndex;
            dataGridView1.Rows[index].Visible = false;
            if (dataGridView1.Rows[index].Cells[0].Value.ToString() == String.Empty)
            {
                dataGridView1.Rows[index].Cells[5].Value = RowState.Deleted;
                return;
            }
            dataGridView1.Rows[index].Cells[5].Value = RowState.Deleted;
            id_supplier = null;
        }
        new private void Update() // Принятие изменения
        {
            dataBase.openConnection();
            for (int index = 0; index < dataGridView1.Rows.Count; index++)
            {
                var rowState = (RowState)dataGridView1.Rows[index].Cells[5].Value;
                if (rowState == RowState.Existed)
                    continue;
                if (rowState == RowState.Deleted)
                {
                    var id = dataGridView1.Rows[index].Cells[0].Value;
                    var deleteQuery = $"delete from Suppliers where id_supplier = {id}";
                    var command = new SqlCommand(deleteQuery, dataBase.GetConnection());
                    command.ExecuteNonQuery();
                }
            }
            dataBase.closeConnection();
        }

        private void button_delete_Click(object sender, EventArgs e) // Нажатие на кнопку Удалить
        {
            dataBase.openConnection();
            string admin = $"SELECT O.id_supplier From Suppliers S inner join OrderUpplier O ON S.id_supplier = O.id_supplier WHERE S.id_supplier = '{id_supplier}'"; // Проверк наличие ссылок в БД
            SqlDataAdapter sda = new SqlDataAdapter(admin, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count < 1)
            {
                if (id_supplier == null)
                {
                    MessageBox.Show("Не выделена запись для удаления!!!");
                }
                else
                {
                    deleteRow();
                    save = true;
                }
            }
            else
            {
                MessageBox.Show("Нельзя удалить запись, на которую есть ссылка!!!");
            }
            dataBase.closeConnection();
        }

        private void Supplier_Load(object sender, EventArgs e)
        {
            CreateColumns();
            RefresDataGird(dataGridView1);
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (save == true)
            {
                Update();
                save = false;
            }
        }
        private void labelUpdate_MouseEnter(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.Black;
        }

        private void labelUpdate_MouseLeave(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.FromArgb(4, 52, 108);
        }
    }
}
