﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class Work : Form // Форма списка заданий на работу
    {
        string id_work; // Переменные для передачи на форму измения
        string condition;
        string employee;
        string data_start;
        string client;
        string type_work;
        bool save;
        DataBase dataBase = new DataBase();
        public Work()
        {
            InitializeComponent();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            MainMenu mainMenu = new MainMenu();
            mainMenu.ShowDialog();
        }
        private void CreateColumns() // Создание столбцов
        {
            dataGridView1.Columns.Add("id_work", "id");
            dataGridView1.Columns.Add("condition", "Сотстояние");
            dataGridView1.Columns.Add("employee", "Исполнитель");
            dataGridView1.Columns.Add("data_start", "Дата начала");
            dataGridView1.Columns.Add("client", "Заказчик");
            dataGridView1.Columns.Add("type_work", "Вид работы");
            dataGridView1.Columns.Add("", String.Empty);
        }
        private void ReadSingleRow(DataGridView dgw, IDataRecord record) // Вывод данных
        {
            dgw.Rows.Add(record.GetInt32(0), record.GetString(1), record.GetString(2), record.GetDateTime(3).ToString("d MMMM yyyy"), record.GetString(4), record.GetString(5), RowState.ModifiedNew);
        }
        private void RefresDataGird(DataGridView dgw) // Взятие данных из БД
        {
            dgw.Rows.Clear();
            dataGridView1.Columns[0].Visible = false;
            dataGridView1.Columns[6].Visible = false;
            string queryString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client";
            SqlCommand command = new SqlCommand(queryString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader reader = command.ExecuteReader();
            while (reader.Read())
            {
                ReadSingleRow(dgw, reader);
            }
            reader.Close();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void Work_Load(object sender, EventArgs e)
        {
            dataBase.openConnection();
            // Создание перечисления состояний
            string status = $"Select condition From Condition";
            SqlCommand com_status = new SqlCommand(status, dataBase.GetConnection());  
            SqlDataReader read_status = com_status.ExecuteReader();
            textStatus.Items.Add("");
            while (read_status.Read())
            {
                textStatus.Items.Add(read_status.GetString(0));
            }
            read_status.Close();
            // Создание перечисления заказчиков
            string client = $"Select name_organization From Client";
            SqlCommand com_client = new SqlCommand(client, dataBase.GetConnection());
            SqlDataReader read_client = com_client.ExecuteReader();
            textClient.Items.Add("");
            while (read_client.Read())
            {
                textClient.Items.Add(read_client.GetString(0));
            }
            read_client.Close();
            // Создание перечисления заказчиков
            string employee = $"Select surname From Employee";
            SqlCommand com_employee = new SqlCommand(employee, dataBase.GetConnection());
            SqlDataReader read_employee = com_employee.ExecuteReader();
            textEmployee.Items.Add("");
            while (read_employee.Read())
            {
                textEmployee.Items.Add(read_employee.GetString(0));
            }
            read_employee.Close();
            ////////////////////////////
            CreateColumns();
            RefresDataGird(dataGridView1);
            dataBase.closeConnection();
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (save == true)
            {
                Update();
                save = false;
            }
        }

        private void labelUpdate_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }
        private void Search(DataGridView dgw) // Поиск
        {
            dgw.Rows.Clear();
            string searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client";
            if (textStatus.Text != "")
            {
                if(textClient.Text != "")
                {
                    if(textEmployee.Text != "")
                    {
                        searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE C.condition  = '{textStatus.Text}' and Cl.name_organization = '{textClient.Text}' and E.surname = '{textEmployee.Text}'";
                    }
                    else
                    {
                        searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE C.condition  = '{textStatus.Text}' and Cl.name_organization = '{textClient.Text}'";
                    }
                }
                else
                {
                    if (textEmployee.Text != "")
                    {
                        searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE C.condition  = '{textStatus.Text}' and E.surname = '{textEmployee.Text}'";
                    }
                    else
                    {
                        searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE C.condition  = '{textStatus.Text}'";
                    }
                }
            }
            else
            {
                if (textClient.Text != "")
                {
                    if (textEmployee.Text != "")
                    {
                        searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE Cl.name_organization = '{textClient.Text}' and E.surname = '{textEmployee.Text}'";
                    }
                    else
                    {
                        searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE Cl.name_organization = '{textClient.Text}'";
                    }
                }
                else
                {
                    if (textEmployee.Text != "")
                    {
                        searchString = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE E.surname = '{textEmployee.Text}'";
                    }
                }
            }
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                ReadSingleRow(dgw, read);
            }
            read.Close();
            dataBase.closeConnection();
        }
        private void deleteRow() // Пометка на удаление
        {
            int index = dataGridView1.CurrentCell.RowIndex;
            dataGridView1.Rows[index].Visible = false;
            if (dataGridView1.Rows[index].Cells[0].Value.ToString() == String.Empty)
            {
                dataGridView1.Rows[index].Cells[6].Value = RowState.Deleted;
                return;
            }
            dataGridView1.Rows[index].Cells[6].Value = RowState.Deleted;
            id_work = null;
        }
        new private void Update() // Принятие изменений
        {
            dataBase.openConnection();
            for (int index = 0; index < dataGridView1.Rows.Count; index++)
            {
                var rowState = (RowState)dataGridView1.Rows[index].Cells[6].Value;
                if (rowState == RowState.Existed)
                    continue;
                if (rowState == RowState.Deleted)
                {
                    var id = dataGridView1.Rows[index].Cells[0].Value;
                    var deleteQuery = $"delete from Work where id_work = {id}";
                    var command = new SqlCommand(deleteQuery, dataBase.GetConnection());
                    command.ExecuteNonQuery();
                }
            }
            dataBase.closeConnection();
        }

        private void button_delete_Click(object sender, EventArgs e) // Удаление записей при нажатие кнопки удалить
        {
            dataBase.openConnection();
            string admin = $"Select W.id_work, C.condition, E.surname, W.data_start, Cl.name_organization, T.type_work From Work W inner join Condition C ON W.id_condition = C.id_condition inner join Employee E ON E.id_employee = W.id_employee inner join Type_work T ON W.id_type_work = T.id_type_work inner join Client Cl ON Cl.id_client = W.id_client WHERE Cl.id_client = '{id_work}'";
            SqlDataAdapter sda = new SqlDataAdapter(admin, dataBase.GetConnection()); // Проверок ссылок на записи
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count < 1)
            {
                if (id_work == null)
                {
                    MessageBox.Show("Не выделена запись для удаления!!!");
                }
                else
                {
                    deleteRow();
                    save = true;
                }
            }
            else
            {
                MessageBox.Show("Нельзя удалить запись, на которую есть ссылка!!!");
            }
            dataBase.closeConnection();
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e) // Выделение записи в dataGriedViev
        {
            var selectedRow = e.RowIndex;
            if (e.RowIndex >= 0)
            {
                DataGridViewRow row = dataGridView1.Rows[selectedRow];
                dataBase.openConnection();
                id_work = row.Cells[0].Value.ToString();
                condition = row.Cells[1].Value.ToString();
                employee = row.Cells[2].Value.ToString();
                data_start = row.Cells[3].Value.ToString();
                client = row.Cells[4].Value.ToString();
                type_work = row.Cells[5].Value.ToString();
                dataBase.closeConnection();
            }
        }
        private void labelUpdate_MouseEnter(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.Black;
        }

        private void labelUpdate_MouseLeave(object sender, EventArgs e)
        {
            labelUpdate.ForeColor = Color.FromArgb(4, 52, 108);
        }

        private void button_add_Click(object sender, EventArgs e)
        {
            this.Hide();
            WorkAdd workAdd = new WorkAdd();
            workAdd.ShowDialog();
        }

        private void button_insert_Click(object sender, EventArgs e) // Переход на форму изменния
        {
            if (id_work == null)
            {
                MessageBox.Show("Не выделена строчка для изменения");
            }
            else
            {
                this.Hide();
                WorkUpd workUpd = new WorkUpd(id_work, condition, employee, data_start, client, type_work);
                workUpd.ShowDialog();
            }
        }

        private void buttonSearch_Click(object sender, EventArgs e)
        {
            if (panelSearch.Visible == true)
            {
                panelSearch.Visible = false;
            }
            else
            {
                panelSearch.Visible = true;
            }
        }

        private void pictureBoxSearch_Click(object sender, EventArgs e)
        {
            if (panelSearch.Visible == true)
            {
                panelSearch.Visible = false;
            }
            else
            {
                panelSearch.Visible = true;
            }
        }

        private void buttonFind_Click(object sender, EventArgs e)
        {
            if((textStatus.Text == "") && (textClient.Text == "") && (textEmployee.Text == ""))
            {
                MessageBox.Show("Не выбрано значение для поиска!!!");
            }
            else
            {
                Search(dataGridView1);
                buttonDeleteSearch.Visible = true;
                panelSearch.Visible = false;
            }
        }

        private void buttonDeleteSearch_Click(object sender, EventArgs e)
        {
            textStatus.Text = "";
            textClient.Text = "";
            textEmployee.Text = "";
            Search(dataGridView1);
            buttonDeleteSearch.Visible = false;
            panelSearch.Visible = false;
        }

        private void Work_Click(object sender, EventArgs e)
        {
            if (panelSearch.Visible == true)
            {
                panelSearch.Visible = false;
            }
        }
    }
}
